<?php

require_once 'base.php';

// Conversion du codage des caractres d'ISO-8859-15 vers UTF-8
if (!function_exists('transcode_characters'))
{
	function transcode_characters($str)
	{
		$str = htmlentities($str, ENT_QUOTES, 'ISO-8859-15');
		$str = utf8_encode($str);
		return($str);
		
	}
}

// Test d'existence physique d'un rpertoire personne partag dans le systme de fichiers du serveur
if (!function_exists('real_name_of_the_personal_shared_folder'))
{
	function real_name_of_the_personal_shared_folder($nickname, $lastname, $firstname, $id_delegation)
	{
		$personal_shared_folder_name = NULL;
		
		$personal_shared_folder_name = replaceInvalidFolderNameChar($nickname.' '.$lastname.' '.$firstname);
		if (file_exists($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$id_delegation.DIRECTORY_SEPARATOR.$personal_shared_folder_name)) return($personal_shared_folder_name);
		
		$personal_shared_folder_name = transcode_characters(replaceInvalidFolderNameChar($personal_shared_folder_name));
		if (file_exists($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$id_delegation.DIRECTORY_SEPARATOR.$personal_shared_folder_name)) return($personal_shared_folder_name);
		
		$personal_shared_folder_name = replaceInvalidFolderNameChar(trim($nickname).' '.trim($lastname).' '.trim($firstname));
		if (file_exists($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$id_delegation.DIRECTORY_SEPARATOR.$personal_shared_folder_name)) return($personal_shared_folder_name);

		$personal_shared_folder_name = transcode_characters(replaceInvalidFolderNameChar($personal_shared_folder_name));
		if (file_exists($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$id_delegation.DIRECTORY_SEPARATOR.$personal_shared_folder_name)) return($personal_shared_folder_name);	

		return($personal_shared_folder_name);
	}
}

// Attribution des droits sur un dossier
if (!function_exists('set_right_on_folder'))
{
	function set_right_on_folder($id_folder, $right, $id_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "upload":
				$table = "bab_fmupload_groups";
				break;
			case "download":
				$table = "bab_fmdownload_groups";
				break;
			case "update":
				$table = "bab_fmupdate_groups";
				break;
			case "manage":
				$table = "bab_fmmanagers_groups";
				break;
			case "notify":
				$table = "bab_fmnotify_groups";
				break;
			case "unzip":
				$table = "bab_fmunzip_groups";
			default:
				$table = "";
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("
			SELECT
			`id` 
			FROM 
			`".$table ."` 
			WHERE 
			`id_object` = '".$babDB->db_escape_string($id_folder)."' 
			AND 
			`id_group` = '".$babDB->db_escape_string($id_group)."'
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$res= $babDB->db_query("
				INSERT 
				INTO 
				`".$table."`
				(
					`id_object`,
					`id_group`
				) VALUES
				(
					'".$babDB->db_escape_string($id_folder)."',
					'".$babDB->db_escape_string($id_group)."'
				)
				");
			}
		}
	}
}

// Affichage du raccourci vers son dossier personnel partag pour un lve ou tudiant
function displayFolderForm()
{
	global $babBody;
	class displayFolderFormClass
	{
		function displayFolderFormClass()
		{
			global $babBody;
			global $babDB;
			global $BAB_SESS_USERID;
			
			require_once($GLOBALS['babInstallPath'].'utilit/fileincl.php');
			
			$this->exist_personal_folder = false;
			$this->must_update_infos = false;
			
			$personal_group_id = NULL;
			$personal_shared_folder_id = NULL;

			$id_user = $BAB_SESS_USERID;
			$res = $babDB->db_query("
			SELECT
			`nickname`,
			`lastname`,
			`firstname`
			FROM
			`bab_users`
			WHERE
			`id` = '".$babDB->db_escape_string($id_user)."'
			");
			$arr = $babDB->db_fetch_array($res);
			$nickname = $arr['nickname'];
			$lastname = $arr['lastname'];
			$firstname = $arr['firstname'];
			$personal_group_name = $nickname." ".$lastname." ".$firstname;
			
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			`name`= '".$babDB->db_escape_string($personal_group_name)."'
			");
			if ($babDB->db_num_rows($res) === 0)
			{
				$personal_group_name = (trim($nickname))." ".(trim($lastname))." ".(trim($firstname));
				$res = $babDB->db_query("
				SELECT
				`id`
				FROM
				`bab_groups`
				WHERE
				`name`= '".$babDB->db_escape_string($personal_group_name)."'
				");
				if ($babDB->db_num_rows($res) > 0)
				{
					$arr = $babDB->db_fetch_array($res);
					$personal_group_id = $arr['id'];
				}
			}
			else
			{
				$arr = $babDB->db_fetch_array($res);
				$personal_group_id = $arr['id'];
			}
			
			if (is_null($personal_group_id))
			{
				
				{
					$this->warning_label = bab_translate("Warning", $GLOBALS['babAddonFolder']) ;
					$info = bab_getUserInfos($BAB_SESS_USERID);
					if (($info["sn"] == $nickname) || ($info["givenname"] == "a_saisir"))
					{
						$this->must_update_infos = true;
						$this->update_personal_info_label = bab_translate("Update personal informations", $GLOBALS['babAddonFolder']);
						$this->message = bab_translate("You must update your name and surname before your personnal folder will be created by the administrator!", $GLOBALS['babAddonFolder']);
					}
					else
					{
						$this->message = bab_translate("Please wait, your personnal folder will be created by the administrator!", $GLOBALS['babAddonFolder']);
					}
				}
			}
			else
			{
				$personal_shared_folder_name = replaceInvalidFolderNameChar($nickname." ".$lastname." ".$firstname);
				$res = $babDB->db_query("
				SELECT 
				`id`,
				`id_dgowner`
				FROM 
				`bab_fm_folders` 
				WHERE 
				`folder`= '".$babDB->db_escape_string($personal_shared_folder_name)."'
				AND
				`sRelativePath` = ''
				");
				if ($babDB->db_num_rows($res) > 0)
				{
					$arr = $babDB->db_fetch_array($res);
					$personal_shared_folder_id = $arr['id'];
					$id_dg = $arr['id_dgowner'];
				}
				else
				{
					$personal_shared_folder_name = replaceInvalidFolderNameChar(trim($nickname)." ".trim($lastname)." ".trim($firstname));
					$res = $babDB->db_query("
					SELECT 
					`id`,
					`id_dgowner`
					FROM 
					`bab_fm_folders` 
					WHERE 
					`folder`= '".$babDB->db_escape_string($personal_shared_folder_name)."'
					AND
					`sRelativePath` = ''
					");
					if ($babDB->db_num_rows($res) > 0)
					{
						$arr = $babDB->db_fetch_array($res);
						$personal_shared_folder_id = $arr['id'];
						$id_dg = $arr['id_dgowner'];
					}
				}
				
				if (!is_null($personal_group_id))
				{
					$this->exist_personal_group = true;
					$real_personal_shared_folder_name = real_name_of_the_personal_shared_folder($nickname, $lastname, $firstname, $id_dg);
					if (!is_null($personal_shared_folder_id) && !is_null($real_personal_shared_folder_name))
					{
						$this->exist_personal_folder = true;
						$this->message = bab_translate("You have a personal shared folder!", $GLOBALS['babAddonFolder']);
						$arr = $babDB->db_fetch_array($res);
						$folder_id = $arr["id"];
						$this->access_to_my_personal_folder_message = bab_translate("Access to the personal folder", $GLOBALS['babAddonFolder']);	
						$this->folder_url = "index.php?tg=fileman&idx=list&id=".$personal_shared_folder_id ."&gr=Y&path=".urlencode($real_personal_shared_folder_name);
					}
					else
					{
						$this->message = bab_translate("You have a personnal group but no personal shared folder!", $GLOBALS['babAddonFolder']);
						$this->message .= "<br />".bab_translate("Please, contact your administrator!", $GLOBALS['babAddonFolder']);
					}
				}
			}
		}
	}
	$obj= new displayFolderFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "view_folder"));
}


// Affichage du formulaire de slection par les enseignants des classes ou des niveaux de formation pour l'affichage des dossiers personnel partags
function displaySelectClassesForm()
{
	global $babBody;
	class displaySelectClassesFormClass
	{
		function displaySelectClassesFormClass()
		{
			global $babDB;
			global $BAB_SESS_USERID;
			global $idx;
			$this->idx = $idx;
			$this->select_label= bab_translate("Select an answer", $GLOBALS['babAddonFolder']);
			$this->res = $babDB->db_query("
			SELECT 
			`bab_groups1`.`name`, 
			`id_group` 
			FROM 
			`bab_groups` AS `bab_groups1`, 
			`bab_groups` AS `bab_groups2`,  
			`bab_users_groups` 
			WHERE  
			`bab_groups1`.`name` LIKE '%Prof' 
			AND 
			`bab_groups1`. `name` != 'EtabProf' 
			AND   
			`bab_groups1`.`name` != 'LgtProf' 
			AND  
			`bab_groups1`.`name` != 'LpProf' 
			AND  
			`bab_groups1`.`name` != 'StsProf' 
			AND  
			`bab_groups1`.`id_parent` = `bab_groups2`.`id` 
			AND 
			`bab_groups1`.`name` !=  CONCAT(`bab_groups2`.`name`, 'Prof') 
			AND 
			`bab_groups1`.`id` = `id_group`
			AND 
			`id_object` = '".$babDB->db_escape_string($BAB_SESS_USERID)."'
			ORDER
			BY
			`bab_groups1`.`name`
			");

			$this->count = $babDB->db_num_rows($this->res);
			$this->validate = bab_translate("Validate", $GLOBALS['babAddonFolder']);"";
		}
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$arr = $babDB->db_fetch_array($this->res);
				$this->id_groupe_prof = $arr['id_group'];
				$this->name_classe_prof = substr($arr['name'], 0, strlen($arr['name']) - 4);
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displaySelectClassesFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "selectclasse"));
}

// Affichage de la liste des groupes personnels et des dossiers personnels partags pour les enseignants
function displayListClasseForm()
{
	global $babBody;
	class displayListClasseFormClass
	{
		function displayListClasseFormClass()
		{
			global $babDB;
			global $babInstallPath;
			global $idx;
			$this->idx = $idx;
			require_once($babInstallPath."utilit/fileincl.php");
			$this->title = bab_translate("View of personal shared folders", $GLOBALS['babAddonFolder']);
			$this->nickname_label = bab_translate("Nickname", $GLOBALS['babAddonFolder']);
			$this->lastname_label = bab_translate("Lastname", $GLOBALS['babAddonFolder']);
			$this->firstname_label = bab_translate("Firstname", $GLOBALS['babAddonFolder']);
			$this->personal_group_label = bab_translate("Personal group", $GLOBALS['babAddonFolder']);
			$this->personnal_shared_folder_label = bab_translate("Personal shared folder", $GLOBALS['babAddonFolder']);
			$this->res1 = $babDB->db_query("
			SELECT 
			`name` 
			FROM 
			`bab_groups` 
			WHERE 
			`id` = '".$babDB->db_escape_string($_POST['id_groupe_prof'])."'
			");

			$arr = $babDB->db_fetch_array($this->res1);
			$name_classe_elv = substr($arr["name"], 0, strlen($arr["name"])-4).'Elv';
			$this->res1 = $babDB->db_query("
			SELECT 
			`bab_dg_groups`.`id`,
			`id_parent`
			FROM
			`bab_dg_groups`, 
			`bab_groups`
			WHERE 
			`bab_groups`.`name` = '".$babDB->db_escape_string($name_classe_elv)."' 
			AND
			`id_group` = `id_parent`
			");
			$arr = $babDB->db_fetch_array($this->res1);
			$this->id_deleg = $arr["id"];
			$this->delegated_group_id = $arr['id_parent'];
			
			$this->res1 = $babDB->db_query("
			SELECT 
			`bab_users`.`id`, 
			`nickname`, 
			`lastname`, 
			`firstname` 
			FROM 
			`bab_groups`,
			`bab_users_groups`, 
			`bab_users` 
			WHERE 
			`name` = '".$babDB->db_escape_string($name_classe_elv)."'
			 AND 
			 `bab_groups`.`id` = `id_group` 
			 AND 
			 `id_object` = `bab_users`.`id` 
			 ORDER BY
			`lastname`, 
			 `firstname`
			 ");
			$this->count = $babDB->db_num_rows($this->res1);
			$this->bgcolor = true;
			$this->validate = bab_translate("Back", $GLOBALS['babAddonFolder']);
		}
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$arr = $babDB->db_fetch_array($this->res1);
				$this->id_user = $arr['id'];
				$this->nickname = $arr['nickname'];
				$this->lastname = $arr['lastname'];
				$this->firstname = $arr['firstname'];
				
				$this->bgcolor = !$this->bgcolor;
				
				$this->exist_personal_group = false;
					
				$this->personal_group_name = $this->nickname." ".$this->lastname." ".$this->firstname;
				$this->res2 = $babDB->db_query("
				SELECT 
				`id`
				FROM 
				`bab_groups`
				WHERE 
				`name` = '".$babDB->db_escape_string($this->personal_group_name)."'
				AND
				`id_parent`= '".$babDB->db_escape_string($this->delegated_group_id)."'
				");
				
				if ($babDB->db_num_rows($this->res2) === 0)
				{
					$this->personnal_groupname = trim($this->nickname)." ".trim($this->lastname)." ".trim($this->firstname);
					$this->res2 = $babDB->db_query("
					SELECT 
					`id`
					FROM 
					`bab_groups`
					WHERE 
					`name` = '".$babDB->db_escape_string($this->personal_group_name)."'
					AND
					`id_parent`= '".$babDB->db_escape_string($this->delegated_group_id)."'
					");
					if ($babDB->db_num_rows($this->res2) === 0)
					{
						$this->personnal_group_name = "&nbsp;";
					}
					else
					{
						$this->exist_personal_group = true;
					}
				}
				else
				{
					$this->exist_personal_group = true;
				}
				
				$this->exist_personal_shared_folder = false;
				$name = replaceInvalidFolderNameChar($this->nickname." ".$this->lastname." ".$this->firstname);
				$this->res2 = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_fm_folders` 
				WHERE 
				`folder` = '".$babDB->db_escape_string($name)."'
				AND
				`sRelativePath` = ''
				AND
				`id_dgowner` = '".$babDB->db_escape_string($this->id_deleg)."'
				");
				if ($babDB->db_num_rows($this->res2) > 0)
				{
					$this->exist_personal_shared_folder = true;
				}
				else
				{			
					$name = replaceInvalidFolderNameChar(trim($this->nickname)." ".trim($this->lastname)." ".trim($this->firstname));
					$this->res2 = $babDB->db_query("
					SELECT 
					`id` 
					FROM 
					`bab_fm_folders` 
					WHERE 
					`folder` = '".$babDB->db_escape_string($name)."'
					AND
					`sRelativePath` = ''
					AND
					`id_dgowner` = '".$babDB->db_escape_string($this->id_deleg)."'
					");
					if ($babDB->db_num_rows($this->res2) > 0)
					{
						$this->exist_personal_shared_folderr = true;
					}
				}
				if ($this->exist_personal_shared_folder)
				{
					$arr = $babDB->db_fetch_array($this->res2);
					$this->folder_id = $arr["id"];
					$this->personal_shared_folder_name = replaceInvalidFolderNameChar(trim($this->nickname).' '.trim($this->lastname).' '.trim($this->firstname));
					$this->real_personal_shared_folder_name = real_name_of_the_personal_shared_folder($this->nickname, $this->lastname, $this->firstname, $this->id_deleg);
					if( !is_null($this->real_personal_shared_folder_name))
					{
						$this->personal_shared_folder_url = "index.php?tg=fileman&idx=list&id=".$this->folder_id."&gr=Y&path=".urlencode($this->real_personal_shared_folder_name);
					}
					else
					{
						$this->exist_personal_shared_folder = false;
						$this->personal_shared_folder_name = "&nbsp;";
					}
				}
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displayListClasseFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "listclasse"));
}

// Affichage du formulaire de slection d'une dlgation pour l'administration des dossiers personnel partags par les administrateurs dlgus
function displaySelectDelegForm()
{
	global $babBody;
	class displaySelectDelegFormClass
	{
		function displaySelectDelegFormClass()
		{
			global $babDB;
			global $idx;
			$this->idx = $idx;
			global $BAB_SESS_USERID;
			$this->select_label= bab_translate("Select an answer", $GLOBALS['babAddonFolder']);
			$this->validate = bab_translate("Validate", $GLOBALS['babAddonFolder']);
			$this->res = $babDB->db_query("
			SELECT 
			`id_dg`,
			`name` 
			FROM 
			`bab_dg_groups`, 
			`bab_dg_admin`
			WHERE 
			`id_dg`= `bab_dg_groups`.`id` 
			AND 
			`id_user` = '".$babDB->db_escape_string($BAB_SESS_USERID)."'
			ORDER
			BY
			`name`
			");
			$this->count = $babDB->db_num_rows($this->res);
		}
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$arr = $babDB->db_fetch_array($this->res);
				$this->id_dg = $arr['id_dg'];
				$this->name_dg = $arr['name'];
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displaySelectDelegFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "selectdeleg"));
}

// Affichage du formulaire de slection d'une classe ou d'un niveau de formation pour l'administration des dossiers personnels partags par les administrateurs dlgus
function displaySelectNiveauForm()
{
	global $babBody;
	class displaySelectNiveauFormClass
	{
		function displaySelectNiveauFormClass()
		{
			global $babDB;
			$this->select_label = bab_translate("Select an answer", $GLOBALS['babAddonFolder']);
			$this->validate = bab_translate("Validate", $GLOBALS['babAddonFolder']);
			$this->id_dg = bab_pp('id_dg', '');
			$this->res = $babDB->db_query("
			SELECT
			`elv_group`.`id`,
			`elv_group`.`name` 
			FROM 
			`bab_groups` AS `elv_group`,
			`bab_groups` AS `deleg_group`,
			`bab_groups` AS `parent_group`,
			`bab_dg_groups` 
			WHERE 
			(
				(
					`elv_group`.`name` != CONCAT(`bab_dg_groups`.`name`,'Elv')
					AND
					UPPER(`parent_group`.`name`) = 'LGT'
				)
				OR
				UPPER(`parent_group`.`name`) IN ('LP', 'STS')
			)	
			AND 
			`elv_group`.`name` LIKE '%Elv'
			AND
			`deleg_group`.`id` = `elv_group`.`id_parent`
			AND
			`parent_group`.`id` = `deleg_group`.`id_parent`
			AND
			`deleg_group`.`id`=`id_group`
			AND 
			`bab_dg_groups`.`id`= '".$babDB->db_escape_string($this->id_dg)."'
			ORDER
			BY
			`elv_group`.`name`
			");
			$this->count = $babDB->db_num_rows($this->res);
		}
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$arr = $babDB->db_fetch_array($this->res);
				$this->id_grp = $arr['id'];
				$this->name_grp = substr($arr['name'], 0, strlen($arr['name']) - 3);
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displaySelectNiveauFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "selectniveau"));
}

// Affichage du formulaire de cration des dossiers personnels partags par les administrateurs dlgus
function displaySelectUserAddForm()
{
	global $babBody;
	class displaySelectUserAddFormClass
	{
		function displaySelectUserAddFormClass()
		{
			global $babDB;
			$this->validate = bab_translate("Validate", $GLOBALS['babAddonFolder']);
			$this->id_dg = bab_pp('id_dg', '');
			$this->id_grp = bab_pp('id_grp', '');
			$this->nickname_label = bab_translate("Nickname", $GLOBALS['babAddonFolder']);
			$this->lastname_label = bab_translate("Lastname", $GLOBALS['babAddonFolder']);
			$this->firstname_label = bab_translate("Firstname", $GLOBALS['babAddonFolder']);
			$this->personal_group_label = bab_translate("Personal group", $GLOBALS['babAddonFolder']);
			$this->personal_shared_folder_label = bab_translate("Personal shared folder", $GLOBALS['babAddonFolder']);
			$this->do_create_label = bab_translate("Do create", $GLOBALS['babAddonFolder']);
			$this->do_not_create_label = bab_translate("Do not create", $GLOBALS['babAddonFolder']);
			$this->res = $babDB->db_query("
			SELECT 
			`bab_users`.`id`,
			`nickname`,
			`lastname`, 
			`firstname` 
			FROM 
			`bab_users`, 
			`bab_users_groups` 
			WHERE 
			`bab_users`.`id` = `id_object`
			AND 
			`id_group` = ".$babDB->db_escape_string($this->id_grp)."
			ORDER BY 
			`lastname`, 
			`firstname`
			");
			$this->count = $babDB->db_num_rows($this->res);
			$this->bgcolor = true;
		}
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$arr = $babDB->db_fetch_array($this->res);
				$this->id_user = $arr['id'];
				$this->nickname = trim($arr['nickname']);
				$this->lastname = trim($arr['lastname']);
				$this->firstname = trim($arr['firstname']);
				$this->indice = $k;
				$res = $babDB->db_query("
				SELECT
				`id`
				FROM
				`bab_fm_folders`
				WHERE
				UPPER(`folder`) LIKE UPPER('".$babDB->db_escape_string($this->nickname)." %')
				AND
				`id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."'
				");
				$this->existing_personal_folder_flag = false;
				if ($babDB->db_num_rows($res) > 0)
				{
					$this->existing_personal_folder_flag = true;
				}
				else
				{
					if ((strtolower($this->nickname) == strtolower($this->lastname)) || (strtolower($this->firstname) == strtolower("a_saisir")))
					{
						$this->checked1 = "";
						$this->checked2 = " checked";
					}
					else
					{
						$this->checked1 = " checked";
						$this->checked2 = "";
					}
				}
				$this->bgcolor = !$this->bgcolor;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displaySelectUserAddFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "selectstudentadd"));
}

// Affichage du compte rendu de cration des dossiers personnels partags par les administrateurs dlgus
function displayActionAddReport()
{
	global $babBody;
	class displayActionAddReportClass
	{
		function displayActionAddReportClass()
		{
			global $babDB;
			global $babInstallPath;
			require_once($babInstallPath."utilit/grpincl.php");
			require_once($babInstallPath."utilit/fileincl.php");
			$this->title = bab_translate("Creation of personal shared folders", $GLOBALS['babAddonFolder']);
			$this->nickname_label = bab_translate("Nickname", $GLOBALS['babAddonFolder']);
			$this->lastname_label = bab_translate("Lastname", $GLOBALS['babAddonFolder']);
			$this->firstname_label = bab_translate("Firstname", $GLOBALS['babAddonFolder']);
			$this->done_action_label = bab_translate("Done action", $GLOBALS['babAddonFolder']);
			$this->validate = bab_translate("Back", $GLOBALS['babAddonFolder']);
			$this->id_dg = bab_pp('id_dg', '');
			$this->id_grp = bab_pp('id_grp', '');
			$this->id_user_array = bab_pp('id_user', array());
			$this->create_array = bab_pp('action', array());
			$this->count = count($this->id_user_array);
			$this->bgcolor = true;
		}
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$this->res1 = $babDB->db_query("
				SELECT 
				`nickname`,
				`lastname`, 
				`firstname` 
				FROM 
				`bab_users` 
				WHERE 
				`id` = '".$babDB->db_escape_string($this->id_user_array[$k])."'
				");
				$arr = $babDB->db_fetch_array($this->res1);
				$this->nickname = trim($arr['nickname']);
				$this->lastname = trim($arr['lastname']);
				$this->firstname = trim($arr['firstname']);
				$this->indice = $k;
				
				switch ($this->create_array[$k])
				{
					case "do_create":
						// Cration du groupe personnel de l'utilisateur
						$this->res2 = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE `name` = '".trim($babDB->db_escape_string($this->nickname)." ".$babDB->db_escape_string($this->lastname)." ".$babDB->db_escape_string($this->firstname))."'");
						$name = trim($this->nickname)." ".trim($this->lastname)." ".trim($this->firstname);;
						if ($babDB->db_num_rows($this->res2) == 0)
						{
							
							$description = bab_translate("Personal user group", $GLOBALS['babAddonFolder']);
							$managerid = $this->id_user_array[$k];
							$this->res3 = $babDB->db_query("
							SELECT 
							`id_group`
							FROM
							`bab_dg_groups` 
							WHERE `id` = '".$babDB->db_escape_string($this->id_dg)."'
							");
							$arr3 = $babDB->db_fetch_array($this->res3);
							$parent = $arr3['id_group'];
							$id_group = bab_createGroup($name, $description, $managerid, $parent);
							$this->res3 = $babDB->db_query("
							UPDATE 
							`bab_groups` 
							SET 
							`mail` = 'N', 
							`ustorage`= 'N', 
							`notes` = 'N', 
							`contacts` = 'N', 
							`directory` = 'N', 
							`pcalendar` = 'N', 
							`id_ocentity` = 0 
							WHERE 
							`id` = '".$babDB->db_escape_string($id_group)."'
							");
							$this->group_report = "Le groupe <b>".$name."</b> a t cr";
						}
						else
						{
							$this->group_report = "Le groupe <b>".$name."</b> existait dj";
							$arr2 = $babDB->db_fetch_array($this->res2);
							$id_group = $arr2['id'];
						}
						bab_addUserToGroup($this->id_user_array[$k], $id_group, true);
						// Cration du rpertoire partag personnel de l'utilisateur physiquement dans le rpertoire d'uploads
						$name = replaceInvalidFolderNameChar(trim($this->nickname)." ".trim($this->lastname)." ".trim($this->firstname));
						if (!file_exists($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$_POST['id_dg'])) @mkdir($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$_POST['id_dg']);
						if (!file_exists($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$_POST['id_dg'].DIRECTORY_SEPARATOR.$name))
						{
							$result = @mkdir($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$_POST['id_dg'].DIRECTORY_SEPARATOR.$name);
							if ($result === true)
							{
								$this->folder_report = bab_translate("The personal shared folder", $GLOBALS['babAddonFolder'])." <b>".$name."</b> ".bab_translate("was created", $GLOBALS['babAddonFolder']);
							}
							else
							{
								$this->folder_report = bab_translate("The personal shared folder", $GLOBALS['babAddonFolder'])." <b>".$name."</b> ".bab_translate("was not created", $GLOBALS['babAddonFolder']);
							}
						}
						else
						{
							$this->folder_report = bab_translate("The personal shared folder", $GLOBALS['babAddonFolder'])." <b>".$name."</b> ".bab_translate("was existing", $GLOBALS['babAddonFolder']);
						}
						if (file_exists($GLOBALS['babUploadPath'].DIRECTORY_SEPARATOR.'fileManager'.DIRECTORY_SEPARATOR.'collectives'.DIRECTORY_SEPARATOR.'DG'.$_POST['id_dg'].DIRECTORY_SEPARATOR.$name))
						{
							$this->res2 = $babDB->db_query("SELECT `id` FROM `bab_fm_folders` WHERE `folder` = '".$name."' AND `id_dgowner` = ".$_POST['id_dg']);
							if ($babDB->db_num_rows($this->res2) == 0)
							{
								$this->res3 = $babDB->db_query("
								INSERT INTO `bab_fm_folders` (
								`sRelativePath`,
								`folder`,
								`manager`,
								`idsa`,
								`filenotify`,
								`active`,
								`version`,
								`id_dgowner`,
								`bhide`,
								`auto_approbation`,
								`baddtags`)
								VALUES(
								'',
								'".$babDB->db_escape_string($name)."',
								".$babDB->db_escape_string($this->id_user_array[$k]).",
								0,
								'Y',
								'Y',
								'Y',
								'".$babDB->db_escape_string($this->id_dg)."',
								'N',
								'Y',
								'N')
								");
								$id_folder = $babDB->db_insert_id($this->res3);
								// Mise en place des droits appropris sur le dossier
								$this->res3 = $babDB->db_query("
								SELECT 
								`name` 
								FROM 
								`bab_groups`
								 WHERE `id` = '".$babDB->db_escape_string($_POST['id_grp'])."'
								 ");
								$temp = $babDB->db_fetch_array($this->res3);
								$temp = substr($temp['name'], 0, strlen($temp['name'])-3).'Prof';
								$this->res3 = $babDB->db_query("
								SELECT 
								`id` 
								FROM 
								`bab_groups` 
								WHERE 
								`name` = '".$babDB->db_escape_string($temp)."'
								");
								$temp = $babDB->db_fetch_array($this->res3);
								$id_grp_ens = $temp['id'];
								$this->res3 = $babDB->db_query("
								SELECT 
								`bab_groups2`.`id` 
								FROM 
								`bab_groups` AS `bab_groups1`, 
								`bab_groups` AS `bab_groups2`,  
								`bab_dg_groups` 
								WHERE 
								`bab_dg_groups`.`id` = ".$_POST['id_dg']." 
								AND 
								`id_group` = `bab_groups1`.`id` 
								AND 
								`bab_groups2`.`name` = CONCAT(`bab_groups1`.`name`, 'Gest')
								");
								$temp = $babDB->db_fetch_array($this->res3);
								$id_grp_gest = $temp['id'];
								set_right_on_folder($id_folder, "upload", $id_group);
								set_right_on_folder($id_folder, "upload", $id_grp_ens);
								set_right_on_folder($id_folder, "download", $id_group);
								set_right_on_folder($id_folder, "download", $id_grp_ens);
								set_right_on_folder($id_folder, "update", $id_group);
								set_right_on_folder($id_folder, "update", $id_grp_ens);
								set_right_on_folder($id_folder, "manage", $id_group);
								set_right_on_folder($id_folder, "manage", $id_grp_ens);
								set_right_on_folder($id_folder, "manage", $id_grp_gest);
								set_right_on_folder($id_folder, "notify", $id_grp_ens);
							}
						}
						break;
						
					case "do_not_create":
						$this->group_report = bab_translate("No created group", $GLOBALS['babAddonFolder']);
						$this->folder_report = bab_translate("No created personal shared folder", $GLOBALS['babAddonFolder']);
						break;
						
					default:
						$this->group_report = "&nbsp;";
						$this->folder_report = "&nbsp;";
						break;
				}
				$this->bgcolor = !$this->bgcolor;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displayActionAddReportClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "actioncreation"));
}

// Affichage du formulaire de suppression des dossiers personnels partags par les administrateurs dlgus
function displaySelectUserDeleteForm()
{
	global $babBody;
	class displaySelectUserDeleteFormClass
	{
		function displaySelectUserDeleteFormClass()
		{
			global $babDB;
			global $babInstallPath;
			require_once($babInstallPath."utilit/fileincl.php");

			$this->validate = bab_translate("Validate", $GLOBALS['babAddonFolder']);
			$this->id_dg = $_POST['id_dg'];
			$this->id_grp = $_POST['id_grp'];
			$this->nickname_label = bab_translate("Nickname", $GLOBALS['babAddonFolder']);
			$this->lastname_label = bab_translate("Lastname", $GLOBALS['babAddonFolder']);
			$this->firstname_label = bab_translate("Firstname", $GLOBALS['babAddonFolder']);
			$this->personal_group_label = bab_translate("Personal group", $GLOBALS['babAddonFolder']);
			$this->personnal_shared_folder_label = bab_translate("Personal shared folder", $GLOBALS['babAddonFolder']);
			$this->group_and_folder_label = bab_translate("Personal group & shared folder", $GLOBALS['babAddonFolder']);

			$this->dodelete_label = bab_translate("Do delete", $GLOBALS['babAddonFolder']);
			$this->donotdelete_label = bab_translate("Do not delete", $GLOBALS['babAddonFolder']);
			$this->res1 = $babDB->db_query("
			SELECT 
			`bab_users`.`id`, 
			`nickname`,
			`lastname`,
			`firstname` 
			FROM 
			`bab_users`,
			`bab_users_groups` 
			WHERE
			`bab_users`.`id` = `id_object` 
			AND 
			`id_group` = '".$babDB->db_escape_string($this->id_grp)."' 
			ORDER BY 
			`lastname`, 
			`firstname`
			");
			$this->count1 = $babDB->db_num_rows($this->res1);
			$this->bgcolor = true;

		}
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count1)
			{
				$arr1 = $babDB->db_fetch_array($this->res1);
				$this->id_user = $arr1['id'];
				$this->nickname = trim($arr1['nickname']);
				$this->lastname = trim($arr1['lastname']);
				$this->firstname = trim($arr1['firstname']);
				$this->indice = $k;
				$group_name = $this->nickname." ".$this->lastname." ".$this->firstname;
				$this->res2 = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_groups` 
				WHERE
				UPPER(`name`) LIKE UPPER('".$babDB->db_escape_string($this->nickname)." %')
				");
				if ($babDB->db_num_rows($this->res2) == 0)
				{
					$this->id_group = "";
					$this->group_name = "&nbsp;";
				}
				else
				{
					$arr2 = $babDB->db_fetch_array($this->res2);
					$this->id_group = $arr2['id'];
					$this->group_name = $group_name;
				}
				$folder_name = replaceInvalidFolderNameChar(trim($this->nickname." ".$this->lastname." ".$this->firstname));
				$this->res2 = $babDB->db_query("
				SELECT 
				`id` 
				FROM 
				`bab_fm_folders` 
				WHERE 
				`folder` = '".$babDB->db_escape_string($folder_name)."' 
				AND 
				`id_dgowner` = '".$babDB->db_escape_string($this->id_dg)."'
				");
				if ($babDB->db_num_rows($this->res2) == 0)
				{
					$this->id_folder = "";
					$this->folder_name = "&nbsp;";
				}
				else
				{
					$arr2 = $babDB->db_fetch_array($this->res2);
					$this->id_folder = $arr2['id'];
					$this->folder_name = $folder_name;
				}
				if (empty($this->id_group) || empty($this->id_folder))
				{
					$this->existe_groupe_personnel = false;
				}
				else
				{
					$this->existe_groupe_personnel = true;
				}
				$this->bgcolor = !$this->bgcolor;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displaySelectUserDeleteFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "selectstudentdelete"));
}

// Affichage du compte rendu de suppression des dossiers personnels partags par les administrateurs dlgus
function displayActionDeleteReport()
{
	global $babBody;
	class displayActionDeleteReportClass
	{
		function displayActionDeleteReportClass()
		{
			global $babDB;
			global $babInstallPath;
			require_once($babInstallPath."utilit/delincl.php");
			require_once($babInstallPath."utilit/grpincl.php");
			require_once($babInstallPath."utilit/fileincl.php");
			$this->title = bab_translate("Creation of the personal shared folders", $GLOBALS['babAddonFolder']);
			$this->nickname_label = bab_translate("Nickname", $GLOBALS['babAddonFolder']);
			$this->lastname_label = bab_translate("Lastname", $GLOBALS['babAddonFolder']);
			$this->firstname_label = bab_translate("Firstname", $GLOBALS['babAddonFolder']);
			$this->done_action_label = bab_translate("Done action", $GLOBALS['babAddonFolder']);
			$this->validate = bab_translate("Back", $GLOBALS['babAddonFolder']);
			$this->id_dg = bab_pp('id_dg', '');
			$this->id_grp = bab_pp('id_grp', '');
			$this->id_user_array = bab_pp('id_user', array());
			$this->id_folder_array = bab_pp('id_folder', array());
			$this->id_group_array = bab_pp('id_group', array());
			$this->action_array = bab_pp('action', array());
			$this->count = count($this->id_user_array);
			$this->bgcolor = true;
		}
		
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$this->res1 = $babDB->db_query("
				SELECT 
				`nickname`,
				`lastname`, 
				`firstname` 
				FROM 
				`bab_users` 
				WHERE 
				`id` = '".$babDB->db_escape_string($this->id_user_array[$k])."'
				");
				$arr = $babDB->db_fetch_array($this->res1);
				$this->nickname = $arr['nickname'];
				$this->lastname = $arr['lastname'];
				$this->firstname = $arr['firstname'];
				$this->indice = $k;
				if (isset($this->action_array[$k]))
				{
					switch ($this->action_array[$k])
					{
						case "do_delete":
						bab_deleteFolder($this->id_folder_array[$k]);
						bab_deleteGroup($this->id_group_array[$k]);
						$this->report = bab_translate("Delete of personal group and personal shared folder of the user", $GLOBALS['babAddonFolder']);
						break;

						case "do_not_delete":
						$this->report = bab_translate("No action done on the personal shared folder", $GLOBALS['babAddonFolder']);
						break;

						default:
						$this->report = "&nbsp;";
						break;
					}
				}
				else
				{
					$this->report = "&nbsp;";
				}
				$this->bgcolor = !$this->bgcolor;

				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displayActionDeleteReportClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."user.html", "actiondelete"));
}

// Dfinition de l'onglet ouvert par dfaut
if( bab_isAccessValid('crgrp_view_groups', 1000))
{
	$idx = bab_rp('idx', 'view');
}
else
{
	$idx = bab_rp('idx', 'add');
}	

// Slection des oprations  raliser
switch($idx)
{
	case 'delete':
		if( bab_isAccessValid('crgrp_view_groups', 1000))
		{
			$babBody->addItemMenu("view", bab_translate("View", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=view");
		}
		if( bab_isAccessValid('crgrp_add_groups', 1000))
		{
			$babBody->addItemMenu("add", bab_translate("Add", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=add");
		}
		if( bab_isAccessValid('crgrp_delete_groups', 1000))
		{
			$babBody->title = bab_translate("Suppression des rpertoires personnels partags", $GLOBALS['babAddonFolder']);
			$babBody->addItemMenu("delete", bab_translate("Delete", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=delete");
			$id_dg = bab_rp('id_dg', '');
			$flag = bab_rp('flag', '');
			if (empty($id_dg))
			{
				$babBody->addError(bab_translate("Select delegation", $GLOBALS['babAddonFolder']));
				displaySelectDelegForm();
			}
			else
			{
				$id_grp = bab_rp('id_grp', '');
				if (empty($id_grp))
				{
					$babBody->addError(bab_translate("Select level", $GLOBALS['babAddonFolder']));
					displaySelectNiveauForm();
				}
				else
				{
					if (empty($flag))
					{
						$babBody->addError(bab_translate("Select users for who must be deleted the personal shared folder", $GLOBALS['babAddonFolder']));
						displaySelectUserDeleteForm();
					}
					else
					{
						displayActionDeleteReport();
					}
				}
			}
		}
		break;
	case 'add':
		if( bab_isAccessValid('crgrp_view_groups', 1000))
		{
			$babBody->addItemMenu("view", bab_translate("View", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=view");
		}
		if( bab_isAccessValid('crgrp_add_groups', 1000))
		{
			$babBody->title = bab_translate("Creation of personal shared folders", $GLOBALS['babAddonFolder']);
			$babBody->addItemMenu("add", bab_translate("Add", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=add");
			$id_dg = bab_rp('id_dg', '');
			$id_grp = bab_rp('id_grp', '');
			$flag = bab_rp('flag', '');
			if (empty($id_dg))
			{
				$babBody->addError(bab_translate("Select delegation", $GLOBALS['babAddonFolder']));
				displaySelectDelegForm();
			}
			else
			{
				if (empty($id_grp))
				{
					$babBody->addError(bab_translate("Select level", $GLOBALS['babAddonFolder']));
					displaySelectNiveauForm();
				}
				else
				{
					if (empty($flag))
					{
						$babBody->addError(bab_translate("Select users for who must be created the personal shared folder", $GLOBALS['babAddonFolder']));
						displaySelectUserAddForm();
					}
					else
					{
						displayActionAddReport();
					}
				}
			}
		}
		if( bab_isAccessValid('crgrp_delete_groups', 1000))
		{
			$babBody->addItemMenu("delete", bab_translate("Delete", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=delete");
		}
		break;
	case 'view':
	default:
		if( bab_isAccessValid('crgrp_view_groups', 1000))
		{
			$res = $babDB->db_query("
			SELECT
			`id` 
			FROM 
			`bab_groups` 
			WHERE 
			`name` ='EtabElv' 
			AND 
			`id_parent` = '1'
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$temp = $babDB->db_fetch_array($res);
				$EtabElvGroupId = $temp["id"];
				if (bab_isMemberOfGroup($EtabElvGroupId))
				{
					$babBody->addItemMenu("view", bab_translate("View", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=add");
					$babBody->addError(bab_translate("Vous tes un lve ou tudiant", $GLOBALS['babAddonFolder']));
					displayFolderForm();
				}
				else
				{
					$res = $babDB->db_query("
					SELECT 
					`id` 
					FROM 
					`bab_groups` 
					WHERE 
					`name` ='EtabProf' 
					AND 
					`id_parent` = '1'
					");
					if ($babDB->db_num_rows($res) > 0)
					{
						$temp = $babDB->db_fetch_array($res);
						$EtabProfGroupId = $temp["id"];
						if (bab_isMemberOfGroup($EtabProfGroupId))
						{
							$id_groupe_prof = bab_rp('id_groupe_prof', '');
							$babBody->addItemMenu("view", bab_translate("View", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=view");
							$babBody->title = bab_translate("View of personal shared folders", $GLOBALS['babAddonFolder']);
							if (empty($id_groupe_prof))
							{
								$babBody->addError(bab_translate("Select class", $GLOBALS['babAddonFolder']));
								displaySelectClassesForm();
							}
							else
							{
								displayListClasseForm();
							}
						}
						else
						{
							$babBody->addItemMenu("view", bab_translate("View", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=add");
							$babBody->addError(bab_translate("Access for students and teachers only", $GLOBALS['babAddonFolder']));
						}
					}
				}
			}
		}

		if( bab_isAccessValid('crgrp_add_groups', 1000))
		{
			$babBody->addItemMenu("add", bab_translate("Add", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=add");
		}

		if( bab_isAccessValid('crgrp_delete_groups', 1000))
		{
			$babBody->addItemMenu("delete", bab_translate("Delete", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."user&idx=delete");
		}
		break;
}

$babBody->setCurrentItemMenu($idx);

?>
